diff --git a/include/kernel-version.mk b/include/kernel-version.mk
index 8890168e88..c02ec66f69 100644
--- a/include/kernel-version.mk
+++ b/include/kernel-version.mk
@@ -3,10 +3,10 @@
 LINUX_RELEASE?=1
 
 LINUX_VERSION-3.18 = .43
-LINUX_VERSION-4.4 = .135
+LINUX_VERSION-4.4 = .136
 
 LINUX_KERNEL_HASH-3.18.43 = 1236e8123a6ce537d5029232560966feed054ae31776fe8481dd7d18cdd5492c
-LINUX_KERNEL_HASH-4.4.135 = 03ccb008824e363d9f83245676b9e0602f604c880dd10577653f3328c37781dc
+LINUX_KERNEL_HASH-4.4.136 = 4315e93b949db42970a81403a387e94d657aa0d6f8986cc494e60c0617366b6b
 
 ifdef KERNEL_PATCHVER
   LINUX_VERSION:=$(KERNEL_PATCHVER)$(strip $(LINUX_VERSION-$(KERNEL_PATCHVER)))
diff --git a/target/linux/apm821xx/config-4.4 b/target/linux/apm821xx/config-4.4
index 68e22ecf8d..d10cb30160 100644
--- a/target/linux/apm821xx/config-4.4
+++ b/target/linux/apm821xx/config-4.4
@@ -41,6 +41,7 @@ CONFIG_BOOKE_WDT=y
 CONFIG_BOUNCE=y
 # CONFIG_CANYONLANDS is not set
 # CONFIG_IKAREM is not set
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CLONE_BACKWARDS=y
 CONFIG_CMDLINE="rootfstype=squashfs noinitrd"
diff --git a/target/linux/ar71xx/config-4.4 b/target/linux/ar71xx/config-4.4
index a8622454b4..91eb9f0de7 100644
--- a/target/linux/ar71xx/config-4.4
+++ b/target/linux/ar71xx/config-4.4
@@ -230,6 +230,7 @@ CONFIG_ATH79_NVRAM=y
 CONFIG_ATH79_PCI_ATH9K_FIXUP=y
 # CONFIG_ATH79_ROUTERBOOT is not set
 CONFIG_ATH79_WDT=y
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CEVT_R4K=y
 CONFIG_CLKDEV_LOOKUP=y
diff --git a/target/linux/ar71xx/patches-4.4/910-unaligned_access_hacks.patch b/target/linux/ar71xx/patches-4.4/910-unaligned_access_hacks.patch
index 374f9be3b4..bbfe7bd803 100644
--- a/target/linux/ar71xx/patches-4.4/910-unaligned_access_hacks.patch
+++ b/target/linux/ar71xx/patches-4.4/910-unaligned_access_hacks.patch
@@ -838,7 +838,7 @@
  
 --- a/net/ipv4/tcp_input.c
 +++ b/net/ipv4/tcp_input.c
-@@ -3820,14 +3820,16 @@ static bool tcp_parse_aligned_timestamp(
+@@ -3822,14 +3822,16 @@ static bool tcp_parse_aligned_timestamp(
  {
  	const __be32 *ptr = (const __be32 *)(th + 1);
  
diff --git a/target/linux/arm64/config-4.4 b/target/linux/arm64/config-4.4
index 53793ef6b1..9ba8eedbba 100644
--- a/target/linux/arm64/config-4.4
+++ b/target/linux/arm64/config-4.4
@@ -85,6 +85,7 @@ CONFIG_BUILD_BIN2C=y
 # CONFIG_CAVIUM_ERRATUM_23144 is not set
 # CONFIG_CAVIUM_ERRATUM_23154 is not set
 # CONFIG_CAVIUM_ERRATUM_27456 is not set
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CLKDEV_LOOKUP=y
 CONFIG_CLKSRC_ACPI=y
diff --git a/target/linux/at91/config-4.4 b/target/linux/at91/config-4.4
index 86d3a0546e..3785695128 100644
--- a/target/linux/at91/config-4.4
+++ b/target/linux/at91/config-4.4
@@ -42,6 +42,7 @@ CONFIG_ATMEL_SDRAMC=y
 CONFIG_AUTO_ZRELADDR=y
 # CONFIG_BLK_DEV_INITRD is not set
 # CONFIG_CACHE_L2X0 is not set
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CLKDEV_LOOKUP=y
 CONFIG_CLKSRC_OF=y
diff --git a/target/linux/ath25/config-4.4 b/target/linux/ath25/config-4.4
index 3985437253..29f8912f46 100644
--- a/target/linux/ath25/config-4.4
+++ b/target/linux/ath25/config-4.4
@@ -17,6 +17,7 @@ CONFIG_ARCH_SUSPEND_POSSIBLE=y
 CONFIG_ARCH_USE_BUILTIN_BSWAP=y
 CONFIG_ARCH_WANT_IPC_PARSE_VERSION=y
 CONFIG_ATH25=y
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CEVT_R4K=y
 CONFIG_CLONE_BACKWARDS=y
diff --git a/target/linux/bcm53xx/config-4.4 b/target/linux/bcm53xx/config-4.4
index 2eb84c5ef7..331ef4f3ad 100644
--- a/target/linux/bcm53xx/config-4.4
+++ b/target/linux/bcm53xx/config-4.4
@@ -78,6 +78,7 @@ CONFIG_BGMAC_BCMA=y
 CONFIG_BOUNCE=y
 CONFIG_BROADCOM_PHY=y
 CONFIG_CACHE_L2X0=y
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CLKDEV_LOOKUP=y
 CONFIG_CLKSRC_ARM_GLOBAL_TIMER_SCHED_CLOCK=y
diff --git a/target/linux/brcm47xx/config-4.4 b/target/linux/brcm47xx/config-4.4
index 97571b62a3..b243ee0073 100644
--- a/target/linux/brcm47xx/config-4.4
+++ b/target/linux/brcm47xx/config-4.4
@@ -34,6 +34,7 @@ CONFIG_BCMA_NFLASH=y
 CONFIG_BCMA_PFLASH=y
 CONFIG_BCMA_SFLASH=y
 # CONFIG_BGMAC_BCMA is not set
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CEVT_R4K=y
 CONFIG_CLONE_BACKWARDS=y
diff --git a/target/linux/brcm63xx/config-4.4 b/target/linux/brcm63xx/config-4.4
index fb448adc1a..63b24ea5ca 100644
--- a/target/linux/brcm63xx/config-4.4
+++ b/target/linux/brcm63xx/config-4.4
@@ -51,6 +51,7 @@ CONFIG_BCM_NET_PHYLIB=y
 CONFIG_BOARD_BCM63XX_DT=y
 CONFIG_BOARD_BCM963XX=y
 CONFIG_BOARD_LIVEBOX=y
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CEVT_R4K=y
 CONFIG_CLONE_BACKWARDS=y
diff --git a/target/linux/gemini/config-4.4 b/target/linux/gemini/config-4.4
index 9572196ae8..730082e4ec 100644
--- a/target/linux/gemini/config-4.4
+++ b/target/linux/gemini/config-4.4
@@ -18,6 +18,7 @@ CONFIG_ARM_PATCH_PHYS_VIRT=y
 CONFIG_ATA=y
 CONFIG_ATAGS=y
 # CONFIG_CACHE_L2X0 is not set
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CLONE_BACKWARDS=y
 CONFIG_CMDLINE="root=/dev/mtdblock2 rootfstype=squashfs,jffs2 noinitrd console=ttyS0,19200 mem=32M"
diff --git a/target/linux/generic/config-4.4 b/target/linux/generic/config-4.4
index a8fd15d1a4..14284ff3c3 100644
--- a/target/linux/generic/config-4.4
+++ b/target/linux/generic/config-4.4
@@ -590,6 +590,7 @@ CONFIG_CARDBUS=y
 # CONFIG_CAVIUM_OCTEON_SOC is not set
 # CONFIG_CB710_CORE is not set
 # CONFIG_CC10001_ADC is not set
+CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE=y
 # CONFIG_CC_OPTIMIZE_FOR_SIZE is not set
 # CONFIG_CC_STACKPROTECTOR is not set
 CONFIG_CC_STACKPROTECTOR_NONE=y
diff --git a/target/linux/generic/patches-4.4/203-kallsyms_uncompressed.patch b/target/linux/generic/patches-4.4/203-kallsyms_uncompressed.patch
index cf8a447bbc..d3a5aa7606 100644
--- a/target/linux/generic/patches-4.4/203-kallsyms_uncompressed.patch
+++ b/target/linux/generic/patches-4.4/203-kallsyms_uncompressed.patch
@@ -51,7 +51,7 @@
  	} else if (argc != 1)
 --- a/init/Kconfig
 +++ b/init/Kconfig
-@@ -1345,6 +1345,17 @@ config SYSCTL_ARCH_UNALIGN_ALLOW
+@@ -1358,6 +1358,17 @@ config SYSCTL_ARCH_UNALIGN_ALLOW
  	  the unaligned access emulation.
  	  see arch/parisc/kernel/unaligned.c for reference
  
diff --git a/target/linux/generic/patches-4.4/204-module_strip.patch b/target/linux/generic/patches-4.4/204-module_strip.patch
index a661f98c65..09c62e29ac 100644
--- a/target/linux/generic/patches-4.4/204-module_strip.patch
+++ b/target/linux/generic/patches-4.4/204-module_strip.patch
@@ -89,7 +89,7 @@ Signed-off-by: Felix Fietkau <nbd@nbd.name>
  
 --- a/init/Kconfig
 +++ b/init/Kconfig
-@@ -2033,6 +2033,13 @@ config MODULE_COMPRESS_XZ
+@@ -2046,6 +2046,13 @@ config MODULE_COMPRESS_XZ
  
  endchoice
  
diff --git a/target/linux/generic/patches-4.4/995-mangle_bootargs.patch b/target/linux/generic/patches-4.4/995-mangle_bootargs.patch
index 821370350e..55863882bf 100644
--- a/target/linux/generic/patches-4.4/995-mangle_bootargs.patch
+++ b/target/linux/generic/patches-4.4/995-mangle_bootargs.patch
@@ -40,7 +40,7 @@
  	setup_per_cpu_areas();
 --- a/init/Kconfig
 +++ b/init/Kconfig
-@@ -1655,6 +1655,15 @@ config EMBEDDED
+@@ -1668,6 +1668,15 @@ config EMBEDDED
  	  an embedded system so certain expert options are available
  	  for configuration.
  
diff --git a/target/linux/imx6/config-4.4 b/target/linux/imx6/config-4.4
index a4ced2e49d..52cd714920 100644
--- a/target/linux/imx6/config-4.4
+++ b/target/linux/imx6/config-4.4
@@ -49,6 +49,7 @@ CONFIG_ATAGS=y
 # CONFIG_ATA_SFF is not set
 CONFIG_AUTO_ZRELADDR=y
 CONFIG_CACHE_L2X0=y
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CLKDEV_LOOKUP=y
 CONFIG_CLKSRC_IMX_GPT=y
diff --git a/target/linux/ixp4xx/config-4.4 b/target/linux/ixp4xx/config-4.4
index 1929f85b1f..d46c7a2b73 100644
--- a/target/linux/ixp4xx/config-4.4
+++ b/target/linux/ixp4xx/config-4.4
@@ -33,6 +33,7 @@ CONFIG_ARM_PATCH_PHYS_VIRT=y
 CONFIG_ATAGS=y
 CONFIG_BOUNCE=y
 # CONFIG_CACHE_L2X0 is not set
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CLKSRC_MMIO=y
 CONFIG_CLONE_BACKWARDS=y
diff --git a/target/linux/layerscape/config-4.4 b/target/linux/layerscape/config-4.4
index d334e42fe7..d26bc8f18c 100644
--- a/target/linux/layerscape/config-4.4
+++ b/target/linux/layerscape/config-4.4
@@ -17,6 +17,7 @@ CONFIG_ARM_GIC=y
 CONFIG_BLK_DEV_LOOP=y
 CONFIG_BLK_DEV_SD=y
 # CONFIG_CAVIUM_ERRATUM_27456 is not set
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CLKDEV_LOOKUP=y
 CONFIG_CLKSRC_MMIO=y
diff --git a/target/linux/malta/config-4.4 b/target/linux/malta/config-4.4
index d19006563d..d6bc73f141 100644
--- a/target/linux/malta/config-4.4
+++ b/target/linux/malta/config-4.4
@@ -27,6 +27,7 @@ CONFIG_BOARD_SCACHE=y
 CONFIG_BOOT_ELF32=y
 CONFIG_BOUNCE=y
 CONFIG_BUILTIN_DTB=y
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CEVT_R4K=y
 CONFIG_CLKBLD_I8253=y
diff --git a/target/linux/mxs/config-4.4 b/target/linux/mxs/config-4.4
index 6723f05d31..89db4c9e08 100644
--- a/target/linux/mxs/config-4.4
+++ b/target/linux/mxs/config-4.4
@@ -42,6 +42,7 @@ CONFIG_ARM_THUMB=y
 CONFIG_ATAGS=y
 CONFIG_AUTO_ZRELADDR=y
 # CONFIG_CACHE_L2X0 is not set
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CLKDEV_LOOKUP=y
 CONFIG_CLKSRC_MMIO=y
diff --git a/target/linux/octeon/config-4.4 b/target/linux/octeon/config-4.4
index fd2f26f1ea..c46de19d56 100644
--- a/target/linux/octeon/config-4.4
+++ b/target/linux/octeon/config-4.4
@@ -37,6 +37,7 @@ CONFIG_CAVIUM_OCTEON_LOCK_L2_LOW_LEVEL_INTERRUPT=y
 CONFIG_CAVIUM_OCTEON_LOCK_L2_MEMCPY=y
 CONFIG_CAVIUM_OCTEON_LOCK_L2_TLB=y
 CONFIG_CAVIUM_OCTEON_SOC=y
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CEVT_R4K=y
 CONFIG_CLONE_BACKWARDS=y
diff --git a/target/linux/ramips/mt7620/config-4.4 b/target/linux/ramips/mt7620/config-4.4
index a2a77177f4..6683543f94 100644
--- a/target/linux/ramips/mt7620/config-4.4
+++ b/target/linux/ramips/mt7620/config-4.4
@@ -15,6 +15,7 @@ CONFIG_ARCH_SUSPEND_POSSIBLE=y
 CONFIG_ARCH_USE_BUILTIN_BSWAP=y
 CONFIG_ARCH_WANT_IPC_PARSE_VERSION=y
 CONFIG_AT803X_PHY=y
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CEVT_R4K=y
 CONFIG_CEVT_SYSTICK_QUIRK=y
diff --git a/target/linux/ramips/mt7621/config-4.4 b/target/linux/ramips/mt7621/config-4.4
index 383370b86e..def9620387 100644
--- a/target/linux/ramips/mt7621/config-4.4
+++ b/target/linux/ramips/mt7621/config-4.4
@@ -16,6 +16,7 @@ CONFIG_ARCH_USE_BUILTIN_BSWAP=y
 CONFIG_ARCH_WANT_IPC_PARSE_VERSION=y
 CONFIG_BOARD_SCACHE=y
 CONFIG_BOUNCE=y
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CEVT_R4K=y
 # CONFIG_CEVT_SYSTICK_QUIRK is not set
diff --git a/target/linux/ramips/mt7628/config-4.4 b/target/linux/ramips/mt7628/config-4.4
index 6b04457f17..561d765d01 100644
--- a/target/linux/ramips/mt7628/config-4.4
+++ b/target/linux/ramips/mt7628/config-4.4
@@ -15,6 +15,7 @@ CONFIG_ARCH_SUSPEND_POSSIBLE=y
 CONFIG_ARCH_USE_BUILTIN_BSWAP=y
 CONFIG_ARCH_WANT_IPC_PARSE_VERSION=y
 CONFIG_AT803X_PHY=y
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CEVT_R4K=y
 CONFIG_CEVT_SYSTICK_QUIRK=y
diff --git a/target/linux/ramips/mt7688/config-4.4 b/target/linux/ramips/mt7688/config-4.4
index aad333bfdb..3b7310d1b8 100644
--- a/target/linux/ramips/mt7688/config-4.4
+++ b/target/linux/ramips/mt7688/config-4.4
@@ -15,6 +15,7 @@ CONFIG_ARCH_SUSPEND_POSSIBLE=y
 CONFIG_ARCH_USE_BUILTIN_BSWAP=y
 CONFIG_ARCH_WANT_IPC_PARSE_VERSION=y
 CONFIG_AT803X_PHY=y
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CEVT_R4K=y
 CONFIG_CEVT_SYSTICK_QUIRK=y
diff --git a/target/linux/ramips/rt288x/config-4.4 b/target/linux/ramips/rt288x/config-4.4
index 5f29322874..c576f618b7 100644
--- a/target/linux/ramips/rt288x/config-4.4
+++ b/target/linux/ramips/rt288x/config-4.4
@@ -14,6 +14,7 @@ CONFIG_ARCH_SUPPORTS_UPROBES=y
 CONFIG_ARCH_SUSPEND_POSSIBLE=y
 CONFIG_ARCH_USE_BUILTIN_BSWAP=y
 CONFIG_ARCH_WANT_IPC_PARSE_VERSION=y
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CEVT_R4K=y
 # CONFIG_CEVT_SYSTICK_QUIRK is not set
diff --git a/target/linux/ramips/rt305x/config-4.4 b/target/linux/ramips/rt305x/config-4.4
index b8f6cda469..dd2c97aaec 100644
--- a/target/linux/ramips/rt305x/config-4.4
+++ b/target/linux/ramips/rt305x/config-4.4
@@ -14,6 +14,7 @@ CONFIG_ARCH_SUPPORTS_UPROBES=y
 CONFIG_ARCH_SUSPEND_POSSIBLE=y
 CONFIG_ARCH_USE_BUILTIN_BSWAP=y
 CONFIG_ARCH_WANT_IPC_PARSE_VERSION=y
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CEVT_R4K=y
 CONFIG_CEVT_SYSTICK_QUIRK=y
diff --git a/target/linux/ramips/rt3883/config-4.4 b/target/linux/ramips/rt3883/config-4.4
index 93df68771c..50dd2a8773 100644
--- a/target/linux/ramips/rt3883/config-4.4
+++ b/target/linux/ramips/rt3883/config-4.4
@@ -15,6 +15,7 @@ CONFIG_ARCH_SUPPORTS_UPROBES=y
 CONFIG_ARCH_SUSPEND_POSSIBLE=y
 CONFIG_ARCH_USE_BUILTIN_BSWAP=y
 CONFIG_ARCH_WANT_IPC_PARSE_VERSION=y
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CEVT_R4K=y
 # CONFIG_CEVT_SYSTICK_QUIRK is not set
diff --git a/target/linux/rb532/config-4.4 b/target/linux/rb532/config-4.4
index 7d0bb3ab15..1abdbfc547 100644
--- a/target/linux/rb532/config-4.4
+++ b/target/linux/rb532/config-4.4
@@ -16,6 +16,7 @@ CONFIG_ARCH_WANT_IPC_PARSE_VERSION=y
 CONFIG_ATA=y
 CONFIG_BLK_DEV_LOOP=y
 CONFIG_BLK_DEV_SD=y
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CEVT_R4K=y
 CONFIG_CLONE_BACKWARDS=y
diff --git a/target/linux/zynq/config-4.4 b/target/linux/zynq/config-4.4
index 52080e2ee9..ff9d341f36 100644
--- a/target/linux/zynq/config-4.4
+++ b/target/linux/zynq/config-4.4
@@ -98,6 +98,7 @@ CONFIG_CAN_RAW=y
 # CONFIG_CAN_SOFTING is not set
 # CONFIG_CAN_TI_HECC is not set
 CONFIG_CAN_XILINXCAN=y
+# CONFIG_CC_OPTIMIZE_FOR_PERFORMANCE is not set
 CONFIG_CC_OPTIMIZE_FOR_SIZE=y
 CONFIG_CHR_DEV_SG=y
 CONFIG_CLKDEV_LOOKUP=y