diff --git a/include/kernel-version.mk b/include/kernel-version.mk
index 4a734e5688..be4cc67fe1 100644
--- a/include/kernel-version.mk
+++ b/include/kernel-version.mk
@@ -4,11 +4,11 @@ LINUX_RELEASE?=1
 
 LINUX_VERSION-3.18 = .123
 LINUX_VERSION-4.9 = .129
-LINUX_VERSION-4.14 = .72
+LINUX_VERSION-4.14 = .73
 
 LINUX_KERNEL_HASH-3.18.123 = c10de32c9b31fb619b016a00d77afc394db5a4542e258e927f06a5ead86f8c64
 LINUX_KERNEL_HASH-4.9.129 = 6f5510d3fcfec1bf1e2d9c8e2fdcd7628c1886c6bdb29092adc5ccdf75e39318
-LINUX_KERNEL_HASH-4.14.72 = df925906250bbc40fcf0137d7ad0fb8edc528d926832634f1233b7540564557f
+LINUX_KERNEL_HASH-4.14.73 = 999e38141ccc447df7bf7ce10b8803c12b32274b76d3d5400bf3fd88eee0e31e
 
 remove_uri_prefix=$(subst git://,,$(subst http://,,$(subst https://,,$(1))))
 sanitize_uri=$(call qstrip,$(subst @,_,$(subst :,_,$(subst .,_,$(subst -,_,$(subst /,_,$(1)))))))
diff --git a/target/linux/ar71xx/patches-4.14/910-unaligned_access_hacks.patch b/target/linux/ar71xx/patches-4.14/910-unaligned_access_hacks.patch
index 015c283e1d..ec1d89d6e6 100644
--- a/target/linux/ar71xx/patches-4.14/910-unaligned_access_hacks.patch
+++ b/target/linux/ar71xx/patches-4.14/910-unaligned_access_hacks.patch
@@ -303,7 +303,7 @@
  #endif /* _LINUX_TYPES_H */
 --- a/net/ipv4/af_inet.c
 +++ b/net/ipv4/af_inet.c
-@@ -1351,8 +1351,8 @@ struct sk_buff **inet_gro_receive(struct
+@@ -1352,8 +1352,8 @@ struct sk_buff **inet_gro_receive(struct
  	if (unlikely(ip_fast_csum((u8 *)iph, 5)))
  		goto out_unlock;
  
@@ -567,7 +567,7 @@
  			goto next_ht;
 --- a/net/ipv6/ip6_offload.c
 +++ b/net/ipv6/ip6_offload.c
-@@ -220,7 +220,7 @@ static struct sk_buff **ipv6_gro_receive
+@@ -221,7 +221,7 @@ static struct sk_buff **ipv6_gro_receive
  			continue;
  
  		iph2 = (struct ipv6hdr *)(p->data + off);
diff --git a/target/linux/ath79/patches-4.14/910-unaligned_access_hacks.patch b/target/linux/ath79/patches-4.14/910-unaligned_access_hacks.patch
index d86036fca3..5dec120b03 100644
--- a/target/linux/ath79/patches-4.14/910-unaligned_access_hacks.patch
+++ b/target/linux/ath79/patches-4.14/910-unaligned_access_hacks.patch
@@ -303,7 +303,7 @@
  #endif /* _LINUX_TYPES_H */
 --- a/net/ipv4/af_inet.c
 +++ b/net/ipv4/af_inet.c
-@@ -1351,8 +1351,8 @@ struct sk_buff **inet_gro_receive(struct
+@@ -1352,8 +1352,8 @@ struct sk_buff **inet_gro_receive(struct
  	if (unlikely(ip_fast_csum((u8 *)iph, 5)))
  		goto out_unlock;
  
@@ -556,7 +556,7 @@
  			goto next_ht;
 --- a/net/ipv6/ip6_offload.c
 +++ b/net/ipv6/ip6_offload.c
-@@ -220,7 +220,7 @@ static struct sk_buff **ipv6_gro_receive
+@@ -221,7 +221,7 @@ static struct sk_buff **ipv6_gro_receive
  			continue;
  
  		iph2 = (struct ipv6hdr *)(p->data + off);
diff --git a/target/linux/generic/backport-4.14/324-v4.16-netfilter-flow-table-support-for-IPv6.patch b/target/linux/generic/backport-4.14/324-v4.16-netfilter-flow-table-support-for-IPv6.patch
index cfb13231c6..3e7db09068 100644
--- a/target/linux/generic/backport-4.14/324-v4.16-netfilter-flow-table-support-for-IPv6.patch
+++ b/target/linux/generic/backport-4.14/324-v4.16-netfilter-flow-table-support-for-IPv6.patch
@@ -26,7 +26,7 @@ Signed-off-by: Pablo Neira Ayuso <pablo@netfilter.org>
  struct dst_entry *ip6_dst_lookup_flow(const struct sock *sk, struct flowi6 *fl6,
 --- a/net/ipv6/ip6_output.c
 +++ b/net/ipv6/ip6_output.c
-@@ -383,7 +383,7 @@ static inline int ip6_forward_finish(str
+@@ -381,7 +381,7 @@ static inline int ip6_forward_finish(str
  	return dst_output(net, sk, skb);
  }
  
@@ -35,7 +35,7 @@ Signed-off-by: Pablo Neira Ayuso <pablo@netfilter.org>
  {
  	unsigned int mtu;
  	struct inet6_dev *idev;
-@@ -403,6 +403,7 @@ static unsigned int ip6_dst_mtu_forward(
+@@ -401,6 +401,7 @@ static unsigned int ip6_dst_mtu_forward(
  
  	return mtu;
  }
diff --git a/target/linux/generic/backport-4.14/350-v4.18-ipv6-make-ip6_dst_mtu_forward-inline.patch b/target/linux/generic/backport-4.14/350-v4.18-ipv6-make-ip6_dst_mtu_forward-inline.patch
index f12366f543..daa4d3b3d8 100644
--- a/target/linux/generic/backport-4.14/350-v4.18-ipv6-make-ip6_dst_mtu_forward-inline.patch
+++ b/target/linux/generic/backport-4.14/350-v4.18-ipv6-make-ip6_dst_mtu_forward-inline.patch
@@ -49,7 +49,7 @@ Signed-off-by: Felix Fietkau <nbd@nbd.name>
  struct dst_entry *ip6_dst_lookup_flow(const struct sock *sk, struct flowi6 *fl6,
 --- a/net/ipv6/ip6_output.c
 +++ b/net/ipv6/ip6_output.c
-@@ -383,28 +383,6 @@ static inline int ip6_forward_finish(str
+@@ -381,28 +381,6 @@ static inline int ip6_forward_finish(str
  	return dst_output(net, sk, skb);
  }
  
diff --git a/target/linux/generic/pending-4.14/192-Revert-ubifs-xattr-Don-t-operate-on-deleted-inodes.patch b/target/linux/generic/pending-4.14/192-Revert-ubifs-xattr-Don-t-operate-on-deleted-inodes.patch
deleted file mode 100644
index cd9a758e37..0000000000
--- a/target/linux/generic/pending-4.14/192-Revert-ubifs-xattr-Don-t-operate-on-deleted-inodes.patch
+++ /dev/null
@@ -1,96 +0,0 @@
-From a99708737f566c70651015332e89d0d3b1eb5529 Mon Sep 17 00:00:00 2001
-From: Koen Vandeputte <koen.vandeputte@ncentric.com>
-Date: Mon, 17 Sep 2018 10:13:09 +0200
-Subject: [PATCH] Revert "ubifs: xattr: Don't operate on deleted inodes"
-
-This reverts commit 8a23348d76a1e7716da6e76383281ac82fc071cf.
-
-UBIFS wants to assert that xattr operations are only issued on files
-with positive link count. The said patch made this operations return
--ENOENT for unlinked files such that the asserts will no longer trigger.
-This was wrong since xattr operations are perfectly fine on unlinked
-files.
-Instead the assertions need to be fixed/removed.
-
-Fixes: 11a6fc3dc743 ("ubifs: xattr: Don't operate on deleted inodes")
-Reported-by: Koen Vandeputte <koen.vandeputte@ncentric.com>
-Signed-off-by: Richard Weinberger <richard@nod.at>
----
- fs/ubifs/xattr.c | 24 ------------------------
- 1 file changed, 24 deletions(-)
-
---- a/fs/ubifs/xattr.c
-+++ b/fs/ubifs/xattr.c
-@@ -152,12 +152,6 @@ static int create_xattr(struct ubifs_inf
- 	ui->data_len = size;
- 
- 	mutex_lock(&host_ui->ui_mutex);
--
--	if (!host->i_nlink) {
--		err = -ENOENT;
--		goto out_noent;
--	}
--
- 	host->i_ctime = current_time(host);
- 	host_ui->xattr_cnt += 1;
- 	host_ui->xattr_size += CALC_DENT_SIZE(fname_len(nm));
-@@ -189,7 +183,6 @@ out_cancel:
- 	host_ui->xattr_size -= CALC_XATTR_BYTES(size);
- 	host_ui->xattr_names -= fname_len(nm);
- 	host_ui->flags &= ~UBIFS_CRYPT_FL;
--out_noent:
- 	mutex_unlock(&host_ui->ui_mutex);
- out_free:
- 	make_bad_inode(inode);
-@@ -241,12 +234,6 @@ static int change_xattr(struct ubifs_inf
- 	mutex_unlock(&ui->ui_mutex);
- 
- 	mutex_lock(&host_ui->ui_mutex);
--
--	if (!host->i_nlink) {
--		err = -ENOENT;
--		goto out_noent;
--	}
--
- 	host->i_ctime = current_time(host);
- 	host_ui->xattr_size -= CALC_XATTR_BYTES(old_size);
- 	host_ui->xattr_size += CALC_XATTR_BYTES(size);
-@@ -268,7 +255,6 @@ static int change_xattr(struct ubifs_inf
- out_cancel:
- 	host_ui->xattr_size -= CALC_XATTR_BYTES(size);
- 	host_ui->xattr_size += CALC_XATTR_BYTES(old_size);
--out_noent:
- 	mutex_unlock(&host_ui->ui_mutex);
- 	make_bad_inode(inode);
- out_free:
-@@ -497,12 +483,6 @@ static int remove_xattr(struct ubifs_inf
- 		return err;
- 
- 	mutex_lock(&host_ui->ui_mutex);
--
--	if (!host->i_nlink) {
--		err = -ENOENT;
--		goto out_noent;
--	}
--
- 	host->i_ctime = current_time(host);
- 	host_ui->xattr_cnt -= 1;
- 	host_ui->xattr_size -= CALC_DENT_SIZE(fname_len(nm));
-@@ -522,7 +502,6 @@ out_cancel:
- 	host_ui->xattr_size += CALC_DENT_SIZE(fname_len(nm));
- 	host_ui->xattr_size += CALC_XATTR_BYTES(ui->data_len);
- 	host_ui->xattr_names += fname_len(nm);
--out_noent:
- 	mutex_unlock(&host_ui->ui_mutex);
- 	ubifs_release_budget(c, &req);
- 	make_bad_inode(inode);
-@@ -562,9 +541,6 @@ static int ubifs_xattr_remove(struct ino
- 
- 	ubifs_assert(inode_is_locked(host));
- 
--	if (!host->i_nlink)
--		return -ENOENT;
--
- 	if (fname_len(&nm) > UBIFS_MAX_NLEN)
- 		return -ENAMETOOLONG;
- 
diff --git a/target/linux/generic/pending-4.14/644-net-pppoe-support-hardware-flow-table-offload.patch b/target/linux/generic/pending-4.14/644-net-pppoe-support-hardware-flow-table-offload.patch
index 935b79d1dd..edba04ccf6 100644
--- a/target/linux/generic/pending-4.14/644-net-pppoe-support-hardware-flow-table-offload.patch
+++ b/target/linux/generic/pending-4.14/644-net-pppoe-support-hardware-flow-table-offload.patch
@@ -73,7 +73,7 @@ Signed-off-by: Felix Fietkau <nbd@nbd.name>
  #include <linux/nsproxy.h>
  #include <net/net_namespace.h>
  #include <net/netns/generic.h>
-@@ -974,8 +979,36 @@ static int pppoe_xmit(struct ppp_channel
+@@ -977,8 +982,36 @@ static int pppoe_xmit(struct ppp_channel
  	return __pppoe_xmit(sk, skb);
  }
  
diff --git a/target/linux/mvebu/patches-4.14/524-PCI-aardvark-set-host-and-device-to-the-same-MAX-payload-size.patch b/target/linux/mvebu/patches-4.14/524-PCI-aardvark-set-host-and-device-to-the-same-MAX-payload-size.patch
index 1847c44803..74e78d3b54 100644
--- a/target/linux/mvebu/patches-4.14/524-PCI-aardvark-set-host-and-device-to-the-same-MAX-payload-size.patch
+++ b/target/linux/mvebu/patches-4.14/524-PCI-aardvark-set-host-and-device-to-the-same-MAX-payload-size.patch
@@ -126,7 +126,7 @@ Signed-off-by: Thomas Petazzoni <thomas.petazzoni@free-electrons.com>
  static int advk_pcie_probe(struct platform_device *pdev)
  {
  	struct device *dev = &pdev->dev;
-@@ -959,6 +1014,9 @@ static int advk_pcie_probe(struct platfo
+@@ -960,6 +1015,9 @@ static int advk_pcie_probe(struct platfo
  	list_for_each_entry(child, &bus->children, node)
  		pcie_bus_configure_settings(child);
  